extern crate sysf;
extern crate async_std;
#[macro_use]
extern crate async_trait;

use async_std::task;
use sysf::config::loader::Loader;
use crate::manager::Manager;

mod manager;

#[async_std::main]
async fn main() {
    let loader = Loader::with_root("/home/eater/projects/systemf/resources/systemd-root");
    let mut manager = Manager::new(loader);
    let mut manager_clone = manager.clone();

    task::spawn(async move {
        manager_clone.target("sysinit.target").await;
        println!("Target set.");
    });

    manager.run().await;
}
