mod client;
mod server;
mod connection;
mod connection_process;
mod connection_unix;

pub use client::*;
pub use server::*;
pub use connection::*;
pub use connection_unix::*;
pub use connection_process::*;

#[derive(Clone, Default, Debug)]
pub struct Response;

#[derive(Clone, Default, Debug)]
pub struct ResponseEnvelope {
    id: u64,
    response: Option<Response>,
}

#[derive(Clone, Default, Debug)]
pub struct Request;

#[derive(Clone, Default, Debug)]
pub struct RequestEnvelope {
    id: u64,
    request: Request,
}

#[derive(Clone, Debug)]
pub struct IncomingMessage {
    client: Client,
    request: RequestEnvelope,
}

impl IncomingMessage {
    pub async fn ack(&mut self) {
        self.client.ack(self.request.id);
    }
}